/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.workflow.action;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.NumberUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.TimeUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.common.dto.MKihonDto;
import jp.mosp.kintai.common.part.KintaiApprovalPart;
import jp.mosp.kintai.common.part.KintaiCommonPart;
import jp.mosp.kintai.dto.MSyukkinboDto;
import jp.mosp.workflow.dto.CtOvertimeRequestDto;
import jp.mosp.workflow.dto.KintaiAppicationDto;
import jp.mosp.workflow.dto.KtHolidayRequestDto;
import jp.mosp.workflow.vo.ManagerApprovalListVo;

/**
 * @author yoshida
 *
 */
public class ManagerApprovalListAction extends MosPWorkflowAction {
	
	// コマンド
	private static final String	CMD_LIST_SHOW		= "K2130";
	private static final String	CMD_LIST_SEARCH		= "K2131";
	private static final String	CMD_LIST_RE_SEARCH	= "K2132";
	private static final String	CMD_LIST_SORT		= "K2133";
	private static final String	CMD_LIST_APPROVAL	= "K2134";
	
	// フィールド
	/**
	 * 表示用リスト
	 */
	List<KintaiAppicationDto>	listApplication;
	

	/**
	 * コンストラクタ
	 */
	public ManagerApprovalListAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの初期化
		prepareVo();
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_LIST_SHOW)) {
			show();
		} else if (cmd.equals(CMD_LIST_SEARCH)) {
			search();
		} else if (cmd.equals(CMD_LIST_RE_SEARCH)) {
			// 再検索
			research();
		} else if (cmd.equals(CMD_LIST_SORT)) {
			// ソート
			sortList(key1);
		} else if (cmd.equals(CMD_LIST_APPROVAL)) {
			// 一括承認
			runApprovalProcess();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new ManagerApprovalListVo();
	}
	
	@Override
	protected void init() throws Exception {
		// ユーザ情報の設定
		getInfo(user.getUserId());
		// プルダウンの設定
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		vo.aryPltSection = StringUtil.addArrayFirstRowSpace(getSectionArrayAll());
		vo.aryPltApplication = StringUtil.addArrayFirstRowSpace(getApplicationArray());
		vo.aryPltStatus = StringUtil.addArrayFirstRowSpace(part().kintaiApproval().getApprovalReasonArray());
		vo.aryPltYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()));
		vo.aryPltMonth = StringUtil.getMonthArray();
		vo.aryPltDay = StringUtil.getDayArray();
	}
	
	@Override
	protected void show() throws Exception {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		Date todayDate = DateUtil.getSystemDate();
		vo.setPltYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		vo.setPltDay(String.valueOf(MospUtility.getDay(todayDate)));
		vo.setPltSection(userBasis.getSCode());
	}
	
	@Override
	protected void search() throws Exception {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		vo.setParams(request);
		// 検索条件による一覧取得
		searchApplicationList();
		vo.setFormerKey(vo.KEY_K_CODE);
		vo.setIsAscending(true);
		vo.initListInfo();
		vo.setSearchmode(ManagerApprovalListVo.SEARCH_ON);
	}
	
	@Override
	protected void research() throws Exception {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		if (vo.getSearchmode() == ManagerApprovalListVo.SEARCH_ON) {
			removeSessionDto();
			searchApplicationList();
			vo.setPageButton();
			sortList();
		}
	}
	
	/**
	 * 検索条件による一覧設定
	 * @throws Exception  例外処理が発生した場合
	 */
	private void searchApplicationList() throws Exception {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		// リストの初期化
		listApplication = new ArrayList<KintaiAppicationDto>();
		// 開始年月日
		Date startDate;
		// 終了年月日
		Date endDate;
		if (vo.getPltDay().length() != 0) {
			startDate = DateUtil.getDate(vo.getPltYear(), vo.getPltMonth(), vo.getPltDay());
			endDate = startDate;
		} else {
			startDate = DateUtil.getFirstDateOfMonth(vo.getPltYear(), vo.getPltMonth());
			endDate = DateUtil.getLastDateOfMonth(vo.getPltYear(), vo.getPltMonth());
		}
		// 承認対象社員一覧リスト
		List<MKihonDto> mKihonList = getApprovalEmployeeList(startDate);
		for (MKihonDto dto : mKihonList) {
			if ((StringUtil.isNotNull(vo.getPltSection()) && !vo.getPltSection().equals(dto.getSCode()))
					|| (StringUtil.isNotNull(vo.getTxtKCode()) && !dto.getKCode().startsWith(vo.getTxtKCode()))
					|| (StringUtil.isNotNull(vo.getTxtKName()) && !dto.getSimei().matches(
							".*" + vo.getTxtKName() + ".*"))) {
				continue;
			}
			if (StringUtil.isNull(vo.getPltApplication()) || vo.getPltApplication().equals(getApplicationArray()[0][0])) {
				// 日次勤怠情報追加
				addSyukkinboInfoToList(dto, startDate, endDate, vo.getPltStatus());
			}
			if (StringUtil.isNull(vo.getPltApplication()) || vo.getPltApplication().equals(getApplicationArray()[1][0])) {
				// 残業申請情報追加
				addOverTimeRequestToList(dto, startDate, endDate, vo.getPltStatus());
			}
			if (StringUtil.isNull(vo.getPltApplication()) || vo.getPltApplication().equals(getApplicationArray()[2][0])) {
				// 休暇申請情報追加
				addHolidayRequestToList(dto, startDate, endDate, vo.getPltStatus());
			}
		}
		// 社員コードでソート。
		VariousUtil.sortList(listApplication, new CompKCode());
		// VOにセット
		vo.setFields(listApplication);
		// 対象が無かった場合のメッセージ設定
		if (vo.getEscAryApplication().length == 0) {
			vo.addErrMessage(getMessage(MospConst.MSG_NO_DATA, ""));
		}
	}
	
	/**
	 * 日次勤怠情報追加
	 * @param mKihonDto		対象社員情報DTO
	 * @param startDate		開始年月日
	 * @param endDate		終了年月日
	 * @param snriyuu		対象承認状況
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void addSyukkinboInfoToList(MKihonDto mKihonDto, Date startDate, Date endDate, String snriyuu)
			throws Exception {
		// 対象期間日次勤怠一覧取得
		List<MSyukkinboDto> listSyukkinbo = syukkinboDao().findForApprovalList(mKihonDto.getKCode(),
				DateUtil.convDateFormatted(startDate), DateUtil.convDateFormatted(endDate), snriyuu);
		for (Object element : listSyukkinbo) {
			MSyukkinboDto dto = (MSyukkinboDto)element;
			if (!KintaiApprovalPart.isDraft(dto)) {
				KintaiAppicationDto appicationDto = new KintaiAppicationDto();
				// コマンド
				appicationDto.setCmd(DayApprovalCardAction.CMD_CARD_SELECT);
				// キー
				appicationDto.setKey(dto.getHizuke());
				// 社員コード
				appicationDto.setKCode(dto.getKCode());
				// 社員氏名
				appicationDto.setSimei(mKihonDto.getSimei());
				// 所属名
				appicationDto.setSName(getSectionName(mKihonDto.getSCode()));
				// 日付
				appicationDto.setDate(DateUtil.convStringDateToDate(dto.getHizuke()));
				// 申請種類
				appicationDto.setApprication(CommonConst.NAM_DAILY_APPROVAL);
				// 承認状況
				appicationDto.setStatus(part().kintaiApproval().getApprovalName(dto));
				// 備考
				StringBuffer remarks = new StringBuffer();
				// 勤務形態
				remarks.append(part().worktype().getWorkTypeName(dto.getKinmu()));
				remarks.append(CommonConst.NAM_COMMON_HALF_KANA_SPACE);
				// 遅刻・早退
				if (dto.getTiJikan() > 0 || dto.getSoJikan() > 0) {
					remarks.append(CommonConst.NAM_LATE_AND_LEAVE_EARLY);
					remarks.append(CommonConst.NAM_COMMON_HALF_KANA_SPACE);
				}
				// 休暇
				if (KintaiCommonPart.isHoliday(dto)) {
					remarks.append(part().mospcode().getHolidayName(dto.getKKRiyuu()));
					remarks.append(CommonConst.NAM_COMMON_HALF_KANA_SPACE);
				}
				// 半休
				if (KintaiCommonPart.isHalfHoliday(dto)) {
					remarks.append(CommonConst.NAM_VACATION_LEAVE_HALF);
					remarks.append(CommonConst.NAM_COMMON_HALF_KANA_SPACE);
				}
				// 時間外代休(半休)
				if (KintaiCommonPart.isOverTimeSubHolidayHalf(dto)) {
					remarks.append(CommonConst.NAM_SUB_HOLIDAY_HALF);
					remarks.append(CommonConst.NAM_COMMON_HALF_KANA_SPACE);
				}
				appicationDto.setRemarks(remarks.toString());
				// チェックボックス
				// 承認者確認
				if (part().kintaiApproval().isApprover(dto.getKCode(), userBasis.getKCode(), dto.getSnRiyuu(),
						DateUtil.convStringDateToDate(dto.getHizuke()))) {
					StringBuffer sb = new StringBuffer();
					// 申請承認種類
					sb.append(CommonConst.CODE_DAILY_APPROVAL);
					sb.append(CommonConst.STR_UNDER_SEPARATOR);
					// 社員コード、日付
					sb.append(dto.getKCode());
					sb.append(CommonConst.STR_UNDER_SEPARATOR);
					sb.append(dto.getHizuke());
					appicationDto.setCkbValue(sb.toString());
				}
				listApplication.add(appicationDto);
			}
		}
	}
	
	/**
	 * 残業申請情報追加
	 * @param mKihonDto		対象社員情報DTO
	 * @param startDate		開始年月日
	 * @param endDate		終了年月日
	 * @param snriyuu		対象承認状況
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void addOverTimeRequestToList(MKihonDto mKihonDto, Date startDate, Date endDate, String snriyuu)
			throws Exception {
		// ワークフロー承認状況コード
		String[] aryStatus = KintaiApprovalPart.toWorkflowStatusArray(snriyuu);
		List<CtOvertimeRequestDto> listOverTime = overTimeDao().findForCondition(mKihonDto.getKCode(), startDate,
				endDate, NumberUtil.getIntParam(aryStatus[0]), aryStatus[1]);
		for (Object element : listOverTime) {
			CtOvertimeRequestDto dto = (CtOvertimeRequestDto)element;
			// 下書き以外
			if (!isStatusDraft(dto.getWorkflow())) {
				KintaiAppicationDto appicationDto = new KintaiAppicationDto();
				// コマンド
				appicationDto.setCmd(OverTimeApprovalCardAction.CMD_CARD_SELECT);
				// キー
				appicationDto.setKey(String.valueOf(dto.getVoucher()));
				// 社員コード
				appicationDto.setKCode(dto.getKCode());
				// 社員氏名
				appicationDto.setSimei(mKihonDto.getSimei());
				// 所属名
				appicationDto.setSName(getSectionName(mKihonDto.getSCode()));
				// 日付
				appicationDto.setDate(dto.getWorkDate());
				// 申請種類
				appicationDto.setApprication(CommonConst.NAM_OVER_TIME_REQUEST);
				String statusCode = toKintaiApprovalStatus(dto.getWorkflow());
				// 承認状況
				appicationDto.setStatus(getApprovalName(statusCode));
				// 備考
				StringBuffer remarks = new StringBuffer();
				remarks.append(TimeUtil.convIntegerTimeToJPHours(dto.getOverTime()));
				appicationDto.setRemarks(remarks.toString());
				// チェックボックス
				// 承認者確認
				if (part().kintaiApproval().isApprover(dto.getKCode(), userBasis.getKCode(), statusCode,
						dto.getWorkDate())) {
					StringBuffer sb = new StringBuffer();
					// 申請承認種類
					sb.append(CommonConst.CODE_OVER_TIME_REQUEST);
					sb.append(CommonConst.STR_UNDER_SEPARATOR);
					// 申請伝票番号
					sb.append(dto.getVoucher());
					appicationDto.setCkbValue(sb.toString());
				}
				listApplication.add(appicationDto);
			}
		}
	}
	
	/**
	 * 休暇申請情報追加
	 * @param mKihonDto		対象社員情報DTO
	 * @param startDate		開始年月日
	 * @param endDate		終了年月日
	 * @param snriyuu		対象承認状況
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void addHolidayRequestToList(MKihonDto mKihonDto, Date startDate, Date endDate, String snriyuu)
			throws Exception {
		// ワークフロー承認状況コード
		String[] aryStatus = KintaiApprovalPart.toWorkflowStatusArray(snriyuu);
		List<KtHolidayRequestDto> listHoliday = holidayDao().findForCondition(mKihonDto.getKCode(), startDate, endDate,
				NumberUtil.getIntParam(aryStatus[0]), aryStatus[1]);
		for (Object element : listHoliday) {
			KtHolidayRequestDto dto = (KtHolidayRequestDto)element;
			// 下書き以外
			if (!isStatusDraft(dto.getWorkflow())) {
				KintaiAppicationDto appicationDto = new KintaiAppicationDto();
				// コマンド
				appicationDto.setCmd(HolidayApprovalCardAction.CMD_CARD_SELECT);
				// キー
				appicationDto.setKey(String.valueOf(dto.getVoucher()));
				// 社員コード
				appicationDto.setKCode(dto.getKCode());
				// 社員氏名
				appicationDto.setSimei(mKihonDto.getSimei());
				// 所属名
				appicationDto.setSName(getSectionName(mKihonDto.getSCode()));
				// 日付
				appicationDto.setDate(dto.getHolidayDate());
				// 申請種類
				appicationDto.setApprication(CommonConst.NAM_HOLIDAY_REQUEST);
				String statusCode = toKintaiApprovalStatus(dto.getWorkflow());
				// 承認状況
				appicationDto.setStatus(getApprovalName(statusCode));
				// 備考
				StringBuffer remarks = new StringBuffer();
				// 休暇理由
				remarks.append(part().holidayRequest().getReasonNameWithType(dto, false));
				appicationDto.setRemarks(remarks.toString());
				// チェックボックス
				// 承認者確認
				if (part().kintaiApproval().isApprover(dto.getKCode(), userBasis.getKCode(), statusCode,
						dto.getHolidayDate())) {
					StringBuffer sb = new StringBuffer();
					// 申請承認種類
					sb.append(CommonConst.CODE_HOLIDAY_REQUEST);
					sb.append(CommonConst.STR_UNDER_SEPARATOR);
					// 申請伝票番号
					sb.append(dto.getVoucher());
					appicationDto.setCkbValue(sb.toString());
				}
				listApplication.add(appicationDto);
			}
		}
	}
	
	/**
	 * 一括承認処理
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void runApprovalProcess() throws Exception {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		String[] arySelectValue = request.getParameterValues(ManagerApprovalListVo.PRM_CKB_APPROVAL);
		Set<Boolean> hashSet = new HashSet<Boolean>();
		int count = 0;
		for (String selectValue : arySelectValue) {
			String[] aryCondition = selectValue.split(CommonConst.STR_UNDER_SEPARATOR);
			String requestType = aryCondition[0];
			String conditionValue = aryCondition[1];
			// コミットフラグ
			boolean canCommit = false;
			if (CommonConst.CODE_DAILY_APPROVAL.equals(requestType)) {
				// 日次勤怠承認処理
				canCommit = runDailyApprovalProcess(conditionValue, DateUtil.convStringDateToDate(aryCondition[2]), "",
						true);
			}
			if (CommonConst.CODE_OVER_TIME_REQUEST.equals(requestType)) {
				// 残業申請承認処理
				canCommit = runOverTimeRequestApproved(getOverTimeRequest(Integer.parseInt(conditionValue)));
			}
			if (CommonConst.CODE_HOLIDAY_REQUEST.equals(requestType)) {
				// 休暇申請承認処理
				canCommit = runHolidayRequestApproved(part().holidayRequest().getHolidayRequest(
						Integer.parseInt(conditionValue)));
			}
			// 承認件数
			if (canCommit) {
				count++;
			}
			hashSet.add(canCommit);
		}
		// エラーが無ければコミットする。
		if (!hashSet.contains(false)) {
			// コミット
			commit();
			// メッセージ
			StringBuffer sb = new StringBuffer();
			sb.append(count);
			sb.append(CommonConst.NAM_COMMON_COUNT);
			sb.append(CommonConst.NAM_APPROVED);
			setMessage(getMessage(CommonConst.MSG_DONE, sb.toString()));
			// 再検索
			searchApplicationList();
			vo.setPageButton();
			sortList();
		}
	}
	
	@Override
	protected void sortList(String key) throws MospException {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		vo.sortList(key, getComparator(key));
		vo.setFields(vo.getList());
	}
	
	@Override
	protected void sortList() throws MospException {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		vo.sortList(getComparator(vo.getFormerKey()));
		vo.setFields(vo.getList());
	}
	
	@Override
	protected Comparator<Object> getComparator(String key) throws MospException {
		ManagerApprovalListVo vo = (ManagerApprovalListVo)getVo();
		Comparator<Object> comp = null;
		if (key.equals(vo.KEY_K_CODE)) {
			comp = new CompKCode();
		} else if (key.equals(vo.KEY_K_NAME)) {
			comp = new CompKName();
		} else if (key.equals(vo.KEY_SECTION)) {
			comp = new CompSection();
		} else if (key.equals(vo.KEY_DATE)) {
			comp = new CompDate();
		} else if (key.equals(vo.KEY_APPLICATION)) {
			comp = new CompApplication();
		} else if (key.equals(vo.KEY_STATUS)) {
			comp = new CompStatus();
		} else {
			throw new MospException(MospConst.EX_SORTKEY_INVALID);
		}
		return comp;
	}
	

	/**
	 * 社員コードによる比較クラス
	 */
	protected static class CompKCode implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= -6587672856397520392L;
		

		public int compare(Object obj1, Object obj2) {
			KintaiAppicationDto dto1 = (KintaiAppicationDto)obj1;
			KintaiAppicationDto dto2 = (KintaiAppicationDto)obj2;
			return dto1.getKCode().compareTo(dto2.getKCode());
		}
	}
	
	/**
	 * 社員氏名による比較クラス
	 */
	protected static class CompKName implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= 6321920436763711779L;
		

		public int compare(Object obj1, Object obj2) {
			KintaiAppicationDto dto1 = (KintaiAppicationDto)obj1;
			KintaiAppicationDto dto2 = (KintaiAppicationDto)obj2;
			return dto1.getSimei().compareTo(dto2.getSimei());
		}
	}
	
	/**
	 * 所属による比較クラス
	 */
	protected static class CompSection implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= -6522555390412324071L;
		

		public int compare(Object obj1, Object obj2) {
			KintaiAppicationDto dto1 = (KintaiAppicationDto)obj1;
			KintaiAppicationDto dto2 = (KintaiAppicationDto)obj2;
			return dto1.getSName().compareTo(dto2.getSName());
		}
	}
	
	/**
	 * 日付による比較クラス
	 */
	protected static class CompDate implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= -2059568153842913234L;
		

		public int compare(Object obj1, Object obj2) {
			KintaiAppicationDto dto1 = (KintaiAppicationDto)obj1;
			KintaiAppicationDto dto2 = (KintaiAppicationDto)obj2;
			return dto1.getDate().compareTo(dto2.getDate());
		}
	}
	
	/**
	 * 申請種類による比較クラス
	 */
	protected static class CompApplication implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= -2395226905215857602L;
		

		public int compare(Object obj1, Object obj2) {
			KintaiAppicationDto dto1 = (KintaiAppicationDto)obj1;
			KintaiAppicationDto dto2 = (KintaiAppicationDto)obj2;
			return dto1.getApprication().compareTo(dto2.getApprication());
		}
	}
	
	/**
	 * 承認状況による比較クラス
	 */
	protected static class CompStatus implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= -8920699379965954199L;
		

		public int compare(Object obj1, Object obj2) {
			KintaiAppicationDto dto1 = (KintaiAppicationDto)obj1;
			KintaiAppicationDto dto2 = (KintaiAppicationDto)obj2;
			return dto1.getStatus().compareTo(dto2.getStatus());
		}
	}
	
}
